diff --git a/wcs/ctl/delete_tenant.py b/wcs/ctl/delete_tenant.py
index 7c0a23815..ca2d9fae4 100644
--- a/wcs/ctl/delete_tenant.py
+++ b/wcs/ctl/delete_tenant.py
@@ -23,8 +23,6 @@ import psycopg2.errorcodes
 from datetime import datetime
 from shutil import rmtree
 
-from django.utils import six
-
 from ..qommon.ctl import Command, make_option
 
 
@@ -61,7 +59,7 @@ class CmdDeleteTenant(Command):
         if pub.is_using_postgresql():
             postgresql_cfg = {}
             for k, v in pub.cfg['postgresql'].items():
-                if v and isinstance(v, six.string_types):
+                if v and isinstance(v, str):
                     postgresql_cfg[k] = v
 
             # if there's a createdb-connection-params, we can do a DROP DATABASE with
diff --git a/wcs/ctl/management/commands/convert_to_sql.py b/wcs/ctl/management/commands/convert_to_sql.py
index 626ec17c2..d50882434 100644
--- a/wcs/ctl/management/commands/convert_to_sql.py
+++ b/wcs/ctl/management/commands/convert_to_sql.py
@@ -14,6 +14,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
+import io
 import os
 import sys
 import psycopg2
@@ -22,7 +23,6 @@ import traceback
 from django.utils.encoding import force_bytes
 from django.core.management.base import BaseCommand
 from django.core.management.base import CommandError
-from django.utils.six import StringIO
 
 from wcs.qommon.publisher import get_publisher_class
 
@@ -82,7 +82,7 @@ class Command(BaseCommand):
                 self.publisher.site_options.add_section('options')
             self.publisher.site_options.set('options', 'postgresql', 'true')
             options_file = os.path.join(self.publisher.app_dir, 'site-options.cfg')
-            stringio = StringIO()
+            stringio = io.StringIO()
             self.publisher.site_options.write(stringio)
             atomic_write(options_file, force_bytes(stringio.getvalue()))
 
diff --git a/wcs/custom_views.py b/wcs/custom_views.py
index 263a06019..9a40a4f99 100644
--- a/wcs/custom_views.py
+++ b/wcs/custom_views.py
@@ -16,7 +16,7 @@
 
 import xml.etree.ElementTree as ET
 
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 from django.utils.encoding import force_text
 from quixote import get_publisher
 
@@ -73,7 +73,7 @@ class CustomView(StorableObject):
         return True
 
     def set_from_qs(self, qs):
-        parsed_qs = urlparse.parse_qsl(qs)
+        parsed_qs = urllib.parse.parse_qsl(qs)
         self.columns = {
             'list': [
                 {'id': key} for (key, value) in parsed_qs if value == 'on' and not key.startswith('filter-')
diff --git a/wcs/data_sources.py b/wcs/data_sources.py
index 9ca96beee..82a9db6f8 100644
--- a/wcs/data_sources.py
+++ b/wcs/data_sources.py
@@ -16,13 +16,11 @@
 
 import collections
 import hashlib
+import urllib.parse
 import xml.etree.ElementTree as ET
 
 from django.template import TemplateSyntaxError, VariableDoesNotExist
-from django.utils import six
 from django.utils.encoding import force_text, force_bytes
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six.moves.urllib import parse as urlparse
 
 from quixote import get_publisher, get_request, get_session
 from quixote.html import TemplateIO
@@ -288,7 +286,7 @@ def get_structured_items(data_source, mode=None):
                 elif len(value[0]) == 1:
                     return [{'id': x[0], 'text': x[0]} for x in value]
                 return value
-            elif isinstance(value[0], six.string_types):
+            elif isinstance(value[0], str):
                 return [{'id': x, 'text': x} for x in value]
             return value
         except:
@@ -619,7 +617,7 @@ class NamedDataSource(XmlStorableObject):
             url += '?'
         else:
             url += '&'
-        url += param_name + '=' + urllib.quote(param_value)
+        url += param_name + '=' + urllib.parse.quote(param_value)
 
         def find_item(items, name, value):
             for item in items:
@@ -769,7 +767,7 @@ def has_chrono(publisher):
 
 def chrono_url(publisher, url):
     chrono_url = publisher.get_site_option('chrono_url')
-    return urlparse.urljoin(chrono_url, url)
+    return urllib.parse.urljoin(chrono_url, url)
 
 
 def collect_agenda_data(publisher):
diff --git a/wcs/fields.py b/wcs/fields.py
index 91a55bd33..da4ac5b1c 100644
--- a/wcs/fields.py
+++ b/wcs/fields.py
@@ -31,7 +31,6 @@ import collections
 from quixote import get_request, get_publisher
 from quixote.html import htmltag, htmltext, TemplateIO
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text, smart_text
 from django.utils.formats import date_format as django_date_format
 from django.utils.html import urlize
@@ -313,7 +312,7 @@ class Field(object):
                         atname = 'item'
                     for v in val:
                         ET.SubElement(el, atname).text = force_text(v, charset, errors='replace')
-                elif isinstance(val, six.string_types):
+                elif isinstance(val, str):
                     el.text = force_text(val, charset, errors='replace')
                 else:
                     el.text = str(val)
@@ -1039,7 +1038,7 @@ class StringField(WidgetField):
 
     def migrate(self):
         changed = super(StringField, self).migrate()
-        if isinstance(self.validation, six.string_types):
+        if isinstance(self.validation, str):
             self.validation = {'type': 'regex', 'value': self.validation}
             changed = True
         return changed
@@ -2498,7 +2497,7 @@ class PageField(Field):
 
     def migrate(self):
         changed = super(PageField, self).migrate()
-        if isinstance(self.condition, six.string_types):
+        if isinstance(self.condition, str):
             if self.condition:
                 self.condition = {'type': 'python', 'value': self.condition}
             else:
@@ -2506,7 +2505,7 @@ class PageField(Field):
             changed = True
         for post_condition in self.post_conditions or []:
             condition = post_condition.get('condition')
-            if isinstance(condition, six.string_types):
+            if isinstance(condition, str):
                 if condition:
                     post_condition['condition'] = {'type': 'python', 'value': condition}
                 else:
diff --git a/wcs/formdata.py b/wcs/formdata.py
index 0fe0f7dba..0b37fd4c3 100644
--- a/wcs/formdata.py
+++ b/wcs/formdata.py
@@ -22,8 +22,6 @@ import re
 import sys
 import time
 
-from django.utils import six
-
 from quixote import get_request, get_publisher, get_session
 from quixote.http_request import Upload
 
@@ -438,11 +436,7 @@ class FormData(StorableObject):
                 if field.prefill and field.prefill.get('type') == 'user':
                     form_user_data[field.prefill['value']] = self.data.get(field.id)
             user_label = ' '.join(
-                [
-                    form_user_data.get(x)
-                    for x in field_name_values
-                    if isinstance(form_user_data.get(x), six.string_types)
-                ]
+                [form_user_data.get(x) for x in field_name_values if isinstance(form_user_data.get(x), str)]
             )
             if user_label != self.user_label:
                 self.user_label = user_label
diff --git a/wcs/formdef.py b/wcs/formdef.py
index 6377665f3..c339b5beb 100644
--- a/wcs/formdef.py
+++ b/wcs/formdef.py
@@ -26,7 +26,6 @@ import json
 import xml.etree.ElementTree as ET
 import datetime
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
 
 from quixote import get_request, get_publisher
@@ -839,7 +838,7 @@ class FormDef(StorableObject):
                 return dict([(unicode2str(k), unicode2str(v)) for k, v in v.items()])
             elif isinstance(v, list):
                 return [unicode2str(x) for x in v]
-            elif isinstance(v, six.string_types):
+            elif isinstance(v, str):
                 return force_str(v)
             else:
                 return v
@@ -869,7 +868,7 @@ class FormDef(StorableObject):
         ):
             formdef.workflow_id = value['workflow'].get('id')
         elif 'workflow' in value:
-            if isinstance(value['workflow'], six.string_types):
+            if isinstance(value['workflow'], str):
                 workflow = value.get('workflow')
             else:
                 workflow = value['workflow'].get('name')
@@ -1009,7 +1008,7 @@ class FormDef(StorableObject):
             element = ET.SubElement(options, 'option')
             element.attrib['varname'] = option
             option_value = self.workflow_options.get(option)
-            if isinstance(option_value, six.string_types):
+            if isinstance(option_value, str):
                 element.text = force_text(self.workflow_options.get(option, ''), charset)
             elif hasattr(option_value, 'base_filename'):
                 ET.SubElement(element, 'filename').text = option_value.base_filename
diff --git a/wcs/forms/backoffice.py b/wcs/forms/backoffice.py
index 8a6b08003..28489bcc5 100644
--- a/wcs/forms/backoffice.py
+++ b/wcs/forms/backoffice.py
@@ -14,7 +14,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from quixote import get_request, get_publisher, get_session, redirect
 from quixote.html import htmltext, TemplateIO
@@ -63,7 +63,7 @@ class FormDefUI(object):
 
             if offset > total_count:
                 get_request().form['offset'] = '0'
-                return redirect('?' + urllib.urlencode(get_request().form))
+                return redirect('?' + urllib.parse.urlencode(get_request().form))
 
         r = TemplateIO(html=True)
 
diff --git a/wcs/forms/common.py b/wcs/forms/common.py
index e4d836925..b34210a2b 100644
--- a/wcs/forms/common.py
+++ b/wcs/forms/common.py
@@ -16,7 +16,7 @@
 
 import time
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from quixote import get_publisher, get_request, get_response, get_session, redirect
 from quixote.directory import Directory
@@ -73,7 +73,7 @@ class FileDirectory(Directory):
             # no such file
             raise errors.TraversalError()
 
-        if component and component not in (file.base_filename, urllib.quote(file.base_filename)):
+        if component and component not in (file.base_filename, urllib.parse.quote(file.base_filename)):
             raise errors.TraversalError()
 
         if file.has_redirect_url():
@@ -688,7 +688,7 @@ class FormStatusPage(Directory, FormTemplateMixin):
                 raise errors.TraversalError()
 
         if getattr(file, 'base_filename'):
-            file_url += urllib.quote(file.base_filename)
+            file_url += urllib.parse.quote(file.base_filename)
         return redirect(file_url)
 
     @classmethod
diff --git a/wcs/forms/root.py b/wcs/forms/root.py
index e487a1cd6..0d9eb6f52 100644
--- a/wcs/forms/root.py
+++ b/wcs/forms/root.py
@@ -15,6 +15,7 @@
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
 import copy
+import io
 import json
 import time
 
@@ -23,9 +24,7 @@ try:
 except ImportError:
     qrcode = None
 
-from django.utils import six
 from django.utils.http import quote
-from django.utils.six import BytesIO
 from django.utils.safestring import mark_safe
 
 import ratelimit.utils
@@ -1164,7 +1163,7 @@ class FormPage(Directory, FormTemplateMixin):
                 continue
             v, locked = field.get_prefill_value(user=prefill_user)
             if locked:
-                if not isinstance(v, six.string_types) and field.convert_value_to_str:
+                if not isinstance(v, str) and field.convert_value_to_str:
                     # convert structured data to strings as if they were
                     # submitted by the browser.
                     v = field.convert_value_to_str(v)
@@ -1522,7 +1521,7 @@ class FormPage(Directory, FormTemplateMixin):
 
     def qrcode(self):
         img = qrcode.make(self.formdef.get_url())
-        s = BytesIO()
+        s = io.BytesIO()
         img.save(s)
         if get_request().get_query() == 'download':
             get_response().set_header(
diff --git a/wcs/middleware.py b/wcs/middleware.py
index 851e2bed1..2b5299d27 100644
--- a/wcs/middleware.py
+++ b/wcs/middleware.py
@@ -20,7 +20,7 @@ import time
 
 from django.http import HttpResponseBadRequest, HttpResponseRedirect
 from django.utils.deprecation import MiddlewareMixin
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from quixote import get_publisher
 from quixote.errors import RequestError
@@ -80,7 +80,7 @@ class PublisherInitialisationMiddleware(MiddlewareMixin):
                 pub.finish_successful_request()  # commits session
                 new_query_string = ''
                 if compat_request.form:
-                    new_query_string = '?' + urllib.urlencode(compat_request.form)
+                    new_query_string = '?' + urllib.parse.urlencode(compat_request.form)
                 response = HttpResponseRedirect(compat_request.get_path() + new_query_string)
                 for name, value in compat_request.response.generate_headers():
                     if name == 'Content-Length':
diff --git a/wcs/monkeypatch.py b/wcs/monkeypatch.py
index fa59040c1..86f45c9d2 100644
--- a/wcs/monkeypatch.py
+++ b/wcs/monkeypatch.py
@@ -19,8 +19,7 @@ import types
 
 import django.template.base
 import django.template.defaulttags
-from django.utils import six
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 
 import quixote
 import quixote.publish
@@ -78,7 +77,7 @@ def redirect(location, permanent=False):
     not honor the redirect).
     """
     request = _thread_local.publisher.get_request()
-    location = urlparse.urljoin(request.get_url(), str(location))
+    location = urllib.parse.urljoin(request.get_url(), str(location))
     return request.response.redirect(location, permanent)
 
 
@@ -105,7 +104,7 @@ def cleanup():
 
 
 for key, value in list(locals().items()):
-    if type(value) in (types.FunctionType,) + six.class_types:
+    if type(value) in (types.FunctionType, type):
         setattr(quixote, key, value)
         setattr(quixote.publish, key, value)
 
diff --git a/wcs/portfolio.py b/wcs/portfolio.py
index 2abe7e451..f02a76223 100644
--- a/wcs/portfolio.py
+++ b/wcs/portfolio.py
@@ -17,10 +17,9 @@
 import json
 import hashlib
 import base64
+import urllib.parse
 
 from django.utils.encoding import force_text
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six.moves.urllib import parse as urlparse
 
 from .qommon import N_, get_logger
 from .qommon.misc import http_get_page, json_loads, http_post_request, urlopen
@@ -37,7 +36,7 @@ def has_portfolio():
 
 def fargo_url(url):
     fargo_url = get_publisher().get_site_option('fargo_url')
-    url = urlparse.urljoin(fargo_url, url)
+    url = urllib.parse.urljoin(fargo_url, url)
     secret, orig = get_secret_and_orig(url)
     if '?' in url:
         url += '&orig=%s' % orig
@@ -70,7 +69,7 @@ def push_document(user, filename, stream):
         payload['user_nameid'] = force_text(user.name_identifiers[0], 'ascii')
     elif user.email:
         payload['user_email'] = force_text(user.email, 'ascii')
-    payload['origin'] = urlparse.urlparse(get_publisher().get_frontoffice_url()).netloc
+    payload['origin'] = urllib.parse.urlparse(get_publisher().get_frontoffice_url()).netloc
     payload['file_name'] = force_text(filename, charset)
     stream.seek(0)
     payload['file_b64_content'] = force_text(base64.b64encode(stream.read()))
@@ -108,9 +107,9 @@ class FargoDirectory(Directory):
             # FIXME: handle error cases
             url = request.form['url']
             document = urlopen(request.form['url']).read()
-            scheme, netloc, path, qs, frag = urlparse.urlsplit(url)
+            scheme, netloc, path, qs, frag = urllib.parse.urlsplit(url)
             path = path.split('/')
-            name = urllib.unquote(path[-1])
+            name = urllib.parse.unquote(path[-1])
             from .qommon.form import PicklableUpload
 
             download = PicklableUpload(name, content_type='application/pdf')
@@ -122,7 +121,7 @@ class FargoDirectory(Directory):
             frontoffice_url = get_publisher().get_frontoffice_url()
             self_url = frontoffice_url
             self_url += '/fargo/pick'
-            return redirect('%spick/?pick=%s' % (self.fargo_url, urllib.quote(self_url)))
+            return redirect('%spick/?pick=%s' % (self.fargo_url, urllib.parse.quote(self_url)))
 
     def set_token(self, token, title):
         get_response().add_javascript(['jquery.js'])
diff --git a/wcs/publisher.py b/wcs/publisher.py
index 352c8581f..2877c5d8b 100644
--- a/wcs/publisher.py
+++ b/wcs/publisher.py
@@ -18,6 +18,7 @@ from contextlib import contextmanager
 import decimal
 import json
 import os
+import pickle
 import random
 import re
 import socket
@@ -25,10 +26,8 @@ import sys
 import traceback
 import zipfile
 
-from django.utils import six
 from django.utils.encoding import force_text
 from django.utils.formats import localize
-from django.utils.six.moves import cPickle
 
 from .Defaults import *
 
@@ -194,7 +193,7 @@ class WcsPublisher(StubWcsPublisher):
         def _decode_list(data):
             rv = []
             for item in data:
-                if isinstance(item, six.string_types):
+                if isinstance(item, str):
                     item = force_str(item)
                 elif isinstance(item, list):
                     item = _decode_list(item)
@@ -207,7 +206,7 @@ class WcsPublisher(StubWcsPublisher):
             rv = {}
             for key, value in data.items():
                 key = force_str(key)
-                if isinstance(value, six.string_types):
+                if isinstance(value, str):
                     value = force_str(value)
                 elif isinstance(value, list):
                     value = _decode_list(value)
@@ -231,7 +230,7 @@ class WcsPublisher(StubWcsPublisher):
             if f in ('config.pck', 'config.json'):
                 results['settings'] = 1
                 if f == 'config.pck':
-                    d = cPickle.loads(data)
+                    d = pickle.loads(data)
                 else:
                     d = json.loads(force_text(data), object_hook=_decode_dict)
                 if 'sp' in self.cfg:
diff --git a/wcs/qommon/__init__.py b/wcs/qommon/__init__.py
index c9daeb8cb..a47cf10e8 100644
--- a/wcs/qommon/__init__.py
+++ b/wcs/qommon/__init__.py
@@ -19,9 +19,8 @@ import threading
 
 import django.apps
 from django.conf import settings
-from django.utils import six
 from django.utils.encoding import force_text
-from django.utils.six.moves import configparser as ConfigParser
+import configparser
 
 from quixote import get_publisher
 
@@ -153,7 +152,7 @@ class AppConfig(django.apps.AppConfig):
     name = 'wcs.qommon'
 
     def ready(self):
-        config = ConfigParser.ConfigParser()
+        config = configparser.ConfigParser()
         if settings.WCS_LEGACY_CONFIG_FILE:
             config.read(settings.WCS_LEGACY_CONFIG_FILE)
         if hasattr(settings, 'WCS_EXTRA_MODULES') and settings.WCS_EXTRA_MODULES:
diff --git a/wcs/qommon/backoffice/listing.py b/wcs/qommon/backoffice/listing.py
index 7e6aea0aa..7212aa2ed 100644
--- a/wcs/qommon/backoffice/listing.py
+++ b/wcs/qommon/backoffice/listing.py
@@ -14,7 +14,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 from quixote.html import htmltext, TemplateIO
 from quixote import get_request, get_response, get_publisher
 
@@ -41,7 +41,7 @@ def pagination_links(offset, limit, total_count, load_js=True):
         query['limit'] = limit
         r += htmltext(
             '<a class="previous-page" data-limit="%s" data-offset="%s" href="?%s"><!--%s--></a>'
-        ) % (limit, query['offset'], urllib.urlencode(query, doseq=1), _('Previous Page'))
+        ) % (limit, query['offset'], urllib.parse.urlencode(query, doseq=1), _('Previous Page'))
     else:
         r += htmltext('<span class="previous-page"><!--%s--></span>') % _('Previous Page')
 
@@ -77,7 +77,7 @@ def pagination_links(offset, limit, total_count, load_js=True):
                 klass,
                 limit,
                 query['offset'],
-                urllib.urlencode(query, doseq=1),
+                urllib.parse.urlencode(query, doseq=1),
                 page_number,
             )
     r += htmltext('</span>')  # <!-- .pages -->
@@ -91,7 +91,7 @@ def pagination_links(offset, limit, total_count, load_js=True):
         r += htmltext('<a class="next-page" data-limit="%s" data-offset="%s" href="?%s"><!--%s--></a>') % (
             limit,
             query['offset'],
-            urllib.urlencode(query, doseq=1),
+            urllib.parse.urlencode(query, doseq=1),
             _('Next Page'),
         )
     else:
@@ -112,7 +112,7 @@ def pagination_links(offset, limit, total_count, load_js=True):
         else:
             r += htmltext('<a data-limit="%s" data-offset="0"" href="?%s">%s</a>') % (
                 page_size,
-                urllib.urlencode(query, doseq=1),
+                urllib.parse.urlencode(query, doseq=1),
                 page_size,
             )
         if page_size >= total_count:
diff --git a/wcs/qommon/ctl.py b/wcs/qommon/ctl.py
index 42867c070..f74fdb923 100644
--- a/wcs/qommon/ctl.py
+++ b/wcs/qommon/ctl.py
@@ -25,7 +25,7 @@ __all__ = [
     'Command',
 ]
 
-from django.utils.six.moves import configparser as ConfigParser
+import configparser
 
 from wcs import qommon
 from . import _
@@ -39,7 +39,7 @@ class Command(object):
     usage_args = '[ options ... ]'
 
     def __init__(self, options=[]):
-        self.config = ConfigParser.ConfigParser()
+        self.config = configparser.ConfigParser()
         self.options = options + [
             make_option('--extra', metavar='DIR', action='append', dest='extra', default=[]),
             make_option('--app-dir', metavar='DIR', action='store', dest='app_dir', default=None),
@@ -53,7 +53,7 @@ class Command(object):
                 sys.exit(1)
             try:
                 self.config.read(base_options.configfile)
-            except ConfigParser.ParsingError as e:
+            except configparser.ParsingError as e:
                 print('Invalid configuration file %s' % base_options.configfile, file=sys.stderr)
                 print(e, file=sys.stderr)
                 sys.exit(1)
diff --git a/wcs/qommon/errors.py b/wcs/qommon/errors.py
index 1d214c4c4..0773d3585 100644
--- a/wcs/qommon/errors.py
+++ b/wcs/qommon/errors.py
@@ -14,7 +14,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from quixote import get_publisher
 import quixote
@@ -61,7 +61,7 @@ class AccessUnauthorizedError(AccessForbiddenError):
         if self.public_msg:
             session.message = ('error', self.public_msg)
         login_url = get_publisher().get_root_url() + 'login/'
-        login_url += '?' + urllib.urlencode({'next': request.get_frontoffice_url()})
+        login_url += '?' + urllib.parse.urlencode({'next': request.get_frontoffice_url()})
         return quixote.redirect(login_url)
 
 
diff --git a/wcs/qommon/evalutils.py b/wcs/qommon/evalutils.py
index 76819b34a..044b7482e 100644
--- a/wcs/qommon/evalutils.py
+++ b/wcs/qommon/evalutils.py
@@ -21,10 +21,10 @@ get_global_eval_dict.
 """
 import base64
 import datetime
+import io
 import time
 
 from django.utils.encoding import force_bytes
-from django.utils.six import BytesIO
 
 from wcs.qommon import force_str
 from wcs.qommon.upload_storage import UploadStorage
@@ -155,13 +155,13 @@ def attachment(content, filename='', content_type=None, strip_metadata=False):
 
     if strip_metadata and Image:
         try:
-            image = Image.open(BytesIO(upload.get_content()))
+            image = Image.open(io.BytesIO(upload.get_content()))
         except OSError:
             pass
         else:
             image_without_exif = Image.new(image.mode, image.size)
             image_without_exif.putdata(image.getdata())
-            content = BytesIO()
+            content = io.BytesIO()
             image_without_exif.save(content, image.format)
             upload = FileField.convert_value_from_anything(
                 {
diff --git a/wcs/qommon/ezt.py b/wcs/qommon/ezt.py
index 1ed0b954e..4f6615827 100644
--- a/wcs/qommon/ezt.py
+++ b/wcs/qommon/ezt.py
@@ -225,10 +225,9 @@ Directives
 
 import datetime
 import html
+import io
 import re
 import os
-from django.utils import six
-from django.utils.six import StringIO as cStringIO
 
 #
 # Formatting types
@@ -472,7 +471,7 @@ class Template:
         to the file object 'fp' and functions are called.
         """
         for step in program:
-            if isinstance(step, six.string_types):
+            if isinstance(step, str):
                 fp.write(step)
             else:
                 step[0](step[1], fp, ctx)
@@ -562,7 +561,7 @@ class Template:
             list = _get_value(valref, ctx)
         except UnknownReference:
             return
-        if isinstance(list, six.string_types):
+        if isinstance(list, str):
             raise NeedSequenceError()
         refname = valref[0]
         ctx.for_index[refname] = idx = [list, 0]
@@ -573,7 +572,7 @@ class Template:
 
     def _cmd_define(self, args, fp, ctx):
         ((name,), unused, section) = args
-        valfp = cStringIO.StringIO()
+        valfp = io.StringIO()
         if section is not None:
             self._execute(section, valfp, ctx)
         ctx.defines[name] = valfp.getvalue()
@@ -673,7 +672,7 @@ def _get_value(value_ref, ctx):
                     raise UnknownReference(refname)
 
     # make sure we return a string instead of some various Python types
-    if isinstance(ob, six.integer_types + (float,)):
+    if isinstance(ob, (int, float)):
         return str(ob)
     if ob is None:
         return ''
diff --git a/wcs/qommon/form.py b/wcs/qommon/form.py
index f6bf631bc..86c44db04 100644
--- a/wcs/qommon/form.py
+++ b/wcs/qommon/form.py
@@ -64,7 +64,6 @@ from quixote.http_request import Upload
 from quixote.util import randbytes
 
 from django.utils.encoding import force_bytes, force_text
-from django.utils import six
 
 from django.conf import settings
 from django.utils.safestring import mark_safe
diff --git a/wcs/qommon/http_request.py b/wcs/qommon/http_request.py
index f07471aa8..d037bcbef 100644
--- a/wcs/qommon/http_request.py
+++ b/wcs/qommon/http_request.py
@@ -19,7 +19,6 @@ import copy
 import re
 import time
 
-from django.utils import six
 from django.utils.encoding import force_bytes, force_text
 from quixote import get_session, get_publisher
 import quixote.http_request
diff --git a/wcs/qommon/ident/franceconnect.py b/wcs/qommon/ident/franceconnect.py
index bc8eb80c2..0264dab7b 100644
--- a/wcs/qommon/ident/franceconnect.py
+++ b/wcs/qommon/ident/franceconnect.py
@@ -20,7 +20,7 @@ import sys
 import uuid
 
 from django.utils.encoding import force_bytes
-from django.utils.six.moves.urllib import parse as urllib
+import urllib.parse
 
 from quixote import redirect, get_session, get_publisher, get_request, get_session_manager
 from quixote.directory import Directory
@@ -313,7 +313,7 @@ class FCAuthMethod(AuthMethod):
 
         nonce = hashlib.sha256(force_bytes(session.id)).hexdigest()
         fc_callback = pub.get_frontoffice_url() + '/ident/fc/callback'
-        qs = urllib.urlencode(
+        qs = urllib.parse.urlencode(
             {
                 'response_type': 'code',
                 'client_id': client_id,
@@ -345,7 +345,7 @@ class FCAuthMethod(AuthMethod):
         }
         response, status, data, auth_header = http_post_request(
             self.get_token_url(),
-            urllib.urlencode(body),
+            urllib.parse.urlencode(body),
             headers={
                 'Content-Type': 'application/x-www-form-urlencoded',
             },
@@ -519,7 +519,7 @@ class FCAuthMethod(AuthMethod):
         get_session_manager().expire_session()
         logout_url = self.get_logout_url()
         post_logout_redirect_uri = get_publisher().get_frontoffice_url()
-        logout_url += '?' + urllib.urlencode(
+        logout_url += '?' + urllib.parse.urlencode(
             {
                 'id_token_hint': id_token,
                 'post_logout_redirect_uri': post_logout_redirect_uri,
diff --git a/wcs/qommon/ident/idp.py b/wcs/qommon/ident/idp.py
index a07a4b644..fbc340f3f 100644
--- a/wcs/qommon/ident/idp.py
+++ b/wcs/qommon/ident/idp.py
@@ -15,6 +15,7 @@
 # along with this program; if not, see <http://www.gnu.org/licenses/>.
 
 import re
+import urllib.parse
 
 try:
     import lasso
@@ -22,8 +23,6 @@ except ImportError:
     lasso = None
 
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six.moves.urllib import parse as urlparse
 
 from quixote.directory import Directory
 from quixote import redirect, get_session, get_response, get_publisher
@@ -159,7 +158,7 @@ class MethodDirectory(Directory):
                 login_url = get_publisher().get_root_url() + 'login/idp/'
             else:
                 login_url = get_publisher().get_root_url() + 'login/'
-            login_url += '?' + urllib.urlencode({'next': get_request().get_frontoffice_url()})
+            login_url += '?' + urllib.parse.urlencode({'next': get_request().get_frontoffice_url()})
             return redirect(login_url)
 
         if get_request().user:
@@ -1066,7 +1065,7 @@ class MethodAdminDirectory(Directory):
             new_domain = None
 
             if old_common_domain_getter_url:
-                old_domain = urlparse.urlparse(old_common_domain_getter_url)[1]
+                old_domain = urllib.parse.urlparse(old_common_domain_getter_url)[1]
                 if ':' in old_domain:
                     old_domain = old_domain.split(':')[0]
                 old_domain_dir = os.path.normpath(os.path.join(dir, '..', old_domain))
@@ -1077,7 +1076,7 @@ class MethodAdminDirectory(Directory):
                     # bad luck, but ignore this
                     pass
             if new_common_domain_getter_url:
-                new_domain = urlparse.urlparse(new_common_domain_getter_url)[1]
+                new_domain = urllib.parse.urlparse(new_common_domain_getter_url)[1]
                 if ':' in new_domain:
                     new_domain = new_domain.split(':')[0]
                 new_domain_dir = os.path.normpath(os.path.join(dir, '..', new_domain))
